chapter\<open>Löb's Theorem pased on Paulson's provability predicate\<close>

theory Loeb
imports Incompleteness.Goedel_II Incompleteness.Goedel_I Incompleteness.Quote 
begin

text\<open>Some lemmas in preparation of Löb's theorem (needed to give the proof of Löb's theorem as outlined in the thesis.\<close>
lemma PfP_inner_ModPon: assumes "ground_fm \<alpha>" "ground_fm \<beta>" shows  "{} \<turnstile> PfP \<guillemotleft>\<alpha> IMP \<beta>\<guillemotright> IMP  PfP \<guillemotleft>\<alpha>\<guillemotright> IMP PfP \<guillemotleft>\<beta>\<guillemotright>"
proof -
  have H: "{} \<turnstile> \<alpha> IMP (\<alpha> IMP \<beta>) IMP \<beta>"
    by blast
  then have aux: "{} \<turnstile> PfP \<guillemotleft>\<alpha>\<guillemotright> IMP PfP \<guillemotleft>\<alpha> IMP \<beta>\<guillemotright> IMP PfP \<guillemotleft>\<beta>\<guillemotright>"
    using assms
    using H
    using qp0.quote_all_MonPon2_PfP_ssubst
    by (auto simp: qp0.quote_all_MonPon2_PfP_ssubst ground_fm_aux_def) (** This is fully inspired by a proof of Paulson *)
  then have  "{ PfP \<guillemotleft>\<alpha> IMP \<beta>\<guillemotright>,  PfP \<guillemotleft>\<alpha>\<guillemotright> } \<turnstile>  PfP \<guillemotleft>\<beta>\<guillemotright>"
    by (metis anti_deduction)
  then have  "{ PfP \<guillemotleft>\<alpha>\<guillemotright>, PfP \<guillemotleft>\<alpha> IMP \<beta>\<guillemotright> } \<turnstile>  PfP \<guillemotleft>\<beta>\<guillemotright>"
     by (metis rotate2)
  thus "{} \<turnstile> PfP \<guillemotleft>\<alpha> IMP \<beta>\<guillemotright> IMP  PfP \<guillemotleft>\<alpha>\<guillemotright> IMP PfP \<guillemotleft>\<beta>\<guillemotright>"
     by (metis Imp_I)
 qed

lemma PfP_distr: assumes "ground_fm \<alpha>" " ground_fm \<beta>" "{} \<turnstile> PfP \<guillemotleft>\<alpha> IMP \<beta>\<guillemotright>" shows "{} \<turnstile> PfP \<guillemotleft>\<alpha>\<guillemotright> IMP PfP \<guillemotleft>\<beta>\<guillemotright>" 
proof -
  have H: "{} \<turnstile> \<alpha> IMP \<beta>"
    using assms
    by (metis proved_iff_proved_PfP)
  thus "{} \<turnstile> PfP \<guillemotleft>\<alpha>\<guillemotright> IMP PfP \<guillemotleft>\<beta>\<guillemotright>"
    using assms
    by (metis Imp_I MonPon_PfP_implies_PfP)
qed

lemma Imp_trans: assumes "{} \<turnstile> \<alpha> IMP \<beta>" "{} \<turnstile> \<beta> IMP \<gamma>" shows "{} \<turnstile> \<alpha> IMP \<gamma>"
proof -
  have H: "{\<alpha>} \<turnstile> \<beta>" 
    using assms(1)
    by (metis anti_deduction)
  then have "{\<beta>} \<turnstile> \<gamma>"
    using assms(2)
    by (metis anti_deduction)
  then have "{\<alpha>} \<turnstile> \<gamma>"
    using H
    by (metis rcut1)
  thus ?thesis
    by (metis Imp_I)
qed

lemma Int_nec: assumes "ground_fm \<delta>" shows "{} \<turnstile> PfP \<guillemotleft>\<delta>\<guillemotright> IMP PfP \<guillemotleft>PfP \<guillemotleft>\<delta>\<guillemotright>\<guillemotright>"
  by (auto simp: Provability ground_fm_aux_def supp_conv_fresh)

lemma S': assumes "{} \<turnstile> \<alpha> IMP \<beta> IMP \<gamma>" "{} \<turnstile> \<alpha> IMP \<beta>" shows "{} \<turnstile> \<alpha> IMP \<gamma>"
proof -
  have "{} \<union> {} \<turnstile> \<alpha> IMP \<gamma>"
    using assms
    by (metis S)
  thus ?thesis
    by simp
qed

text\<open>The proof of Löb's theorem\<close>

theorem Loeb: assumes "ground_fm \<alpha>" "{} \<turnstile> PfP \<guillemotleft>\<alpha>\<guillemotright> IMP \<alpha>" shows "{} \<turnstile> \<alpha>"
proof -
  obtain k::name
    where atoms: "atom k \<sharp> \<alpha>"
    by (metis obtain_fresh)
  obtain \<delta> where del: "{} \<turnstile> \<delta> IFF ((PfP (Var k)) IMP \<alpha>)(k::=\<guillemotleft>\<delta>\<guillemotright>)"
             and suppd: "supp \<delta> = supp ((PfP (Var k)) IMP \<alpha>) - {atom k}"
    by (metis  diagonal)
  then have diag: "{} \<turnstile> \<delta> IFF ((PfP (Var k))(k::=\<guillemotleft>\<delta>\<guillemotright>) IMP \<alpha>(k::=\<guillemotleft>\<delta>\<guillemotright>))"
    by (metis SyntaxN.Neg SyntaxN.Disj)
  moreover have  "atom k \<sharp> \<alpha>"
    using assms
    by simp
  then have diag': "{} \<turnstile> \<delta> IFF ((PfP (Var k))(k::=\<guillemotleft>\<delta>\<guillemotright>) IMP \<alpha>)"
    using diag
    by (metis forget_subst_fm)
  then have diag'': "{} \<turnstile> \<delta> IFF ((PfP \<guillemotleft>\<delta>\<guillemotright>) IMP \<alpha>)"
    by simp
  then have del_supp: "ground_fm \<delta>"
    using assms
    using suppd
     by (auto simp: ground_fm_aux_def supp_conv_fresh) 
  then have imp_supp: "ground_fm  (PfP \<guillemotleft>\<delta>\<guillemotright> IMP \<alpha>)"
    using assms
    using suppd
    by  (auto simp: ground_fm_aux_def supp_conv_fresh) 
  then have prf_del_supp: "ground_fm (PfP \<guillemotleft>\<delta>\<guillemotright>)"
    using suppd
     by  (auto simp: ground_fm_aux_def supp_conv_fresh) 
  then  have H2: "{} \<turnstile> \<delta> IMP ((PfP \<guillemotleft>\<delta>\<guillemotright>) IMP \<alpha>)"
    by (metis Conj_E2 Iff_def Iff_sym diag'') 
  then have H3: "{} \<turnstile> PfP \<guillemotleft>\<delta> IMP ((PfP \<guillemotleft>\<delta>\<guillemotright>) IMP \<alpha>)\<guillemotright>"
    by (metis  proved_iff_proved_PfP H2)
  then have H4: "{} \<turnstile> PfP \<guillemotleft>\<delta>\<guillemotright> IMP (PfP \<guillemotleft>PfP \<guillemotleft>\<delta>\<guillemotright> IMP \<alpha>\<guillemotright>)"
    using imp_supp
    using del_supp
    by (metis PfP_distr)
  then have H5: "{} \<turnstile> PfP \<guillemotleft>PfP \<guillemotleft>\<delta>\<guillemotright> IMP \<alpha>\<guillemotright> IMP PfP \<guillemotleft>PfP \<guillemotleft>\<delta>\<guillemotright>\<guillemotright> IMP PfP \<guillemotleft>\<alpha>\<guillemotright>"
    using assms(1)
    using prf_del_supp
    by (metis PfP_inner_ModPon)
  then have "{} \<turnstile>  PfP \<guillemotleft>\<delta>\<guillemotright> IMP PfP \<guillemotleft>PfP \<guillemotleft>\<delta>\<guillemotright>\<guillemotright> IMP PfP \<guillemotleft>\<alpha>\<guillemotright>"
    using H4
    by (metis Imp_trans)
  then have "{} \<turnstile> PfP \<guillemotleft>\<delta>\<guillemotright> IMP PfP \<guillemotleft>\<alpha>\<guillemotright>"
    using del_supp
    by (metis Int_nec S')
  then have H6: "{} \<turnstile> PfP \<guillemotleft>\<delta>\<guillemotright> IMP \<alpha>"
    using assms(2)
    by (metis Imp_trans)
  then have "{} \<turnstile> \<delta>"
    using diag''
    by (metis Iff_MP2_same)
  then have "{} \<turnstile> PfP \<guillemotleft>\<delta>\<guillemotright>"
    by (metis  proved_iff_proved_PfP)
  thus ?thesis
    using H6
    by (metis MP_same)
qed
  
end